#### zakojska model without predictors ####

results.par = m_grow3_zak0_noP.par  #get the parameters of the model

data = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C11") # data is as usual
# the dataset with no parental cohort and no cohort 2011

unique.mark = unique(data$Mark)  # all individuals


## some trivial code
nrow.mark = rep(0,length(unique.mark))


for (i in 1:length(unique.mark)) {

nrow.mark[i] = nrow(data[data$Mark == unique.mark[i],])

}	

k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u ) 
## compute k (Eq. 7 in the ms)

Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)
## compute Linf (Eq. 7 in the ms)

klinf.nrow = data.frame(Mark = unique.mark, k = k,linf = Linf, num.samp = nrow.mark)
# this dataset has for each individual mark,k,linf and how many times sampled

cor.k.linf.zak.only1 = with(subset(klinf.nrow,num.samp == 1),cor.test(k,linf))

cor.k.linf.zak.over2 =  with(subset(klinf.nrow,num.samp > 2),cor.test(k,linf))




#### gacnik model without predictors ####





results.par = m_grow3_gat0_noP.par #get the parameters of the model

data = subset(allstreams.gatsnik.df, Cohort!="P" & Cohort!="C11")
# the dataset with no parental cohort and no cohort 2011

unique.mark = unique(data$Mark) # all individuals

## some trivial code
nrow.mark = rep(0,length(unique.mark))


for (i in 1:length(unique.mark)) {

nrow.mark[i] = nrow(data[data$Mark == unique.mark[i],])

}	

k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u )
## compute k (Eq. 7 in the ms)
Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)
## compute Linf (Eq. 7 in the ms)


klinf.nrow = data.frame(Mark = unique.mark, k = k,linf = Linf, num.samp = nrow.mark)
# this dataset has for each individual mark,k,linf and how many times sampled

cor.k.linf.gat.only1 = with(subset(klinf.nrow,num.samp == 1),cor.test(k,linf))

cor.k.linf.gat.over2 = with(subset(klinf.nrow,num.samp > 2),cor.test(k,linf))

