require(ggplot2)
require(grid)


#900 600

size.label.x = 20
size.text.x = 15
line.lwd = 0.6
size.label.y = 20
size.text.y = 15
size.legend.text = 15
size.legend.title = 15
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
col.line = "gray20"


data = allstreams.gatsnik.nop.df

sampled = rep(0,50000)

for (i in 1:length(unique(data$Mark))) {

subset.prov = subset(data,Mark == unique(data$Mark)[i])

sampled[i] = nrow(subset.prov)

} 

sampled = sampled[1:sum(sampled>0)]

sampled = as.data.frame(sampled)

gggat.timesamp = ggplot(sampled, aes(x=sampled)) + geom_histogram(aes(y=..density..),
binwidth=1, colour="black", fill="lightgray",origin = -0.5) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(limits=c(0, 0.6),breaks=c(0,0.2,0.4,0.6)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9),limits=c(0.5, 9)) +
	   theme(plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) + labs(x = "Number of times sampled") +
           labs(y = "Frequency")



data = allstreams.zakojska.noP.df

sampled = rep(0,50000)

for (i in 1:length(unique(data$Mark))) {

subset.prov = subset(data,Mark == unique(data$Mark)[i])

sampled[i] = nrow(subset.prov)

} 

sampled = sampled[1:sum(sampled>0)]

sampled = as.data.frame(sampled)

ggzak.timesamp = ggplot(sampled, aes(x=sampled)) + geom_histogram(aes(y=..density..),
binwidth=1, colour="black", fill="lightgray",origin = -0.5) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(limits=c(0, 0.6),breaks=c(0,0.2,0.4,0.6)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9),limits=c(0.5, 9)) +
	   theme(plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y)) + labs(x = "Number of times sampled") +
           labs(y = "Frequency")








ggat <- ggplot(subset(allstreams.gatsnik.df,Mark!="NA" & Cohort!="P"), aes(x = Age, y = Length)) 	  
ggat1  <- ggat + geom_line(aes(group = Mark), lwd = line.lwd,colour=col.line ) +
 #      ggtitle("Gatsnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,200,300,400),limits=c(80, 440)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9,10),limits=c(0, 10)) +
	  labs(x = "Age") +
           labs(y = "Length (mm)") 
	  	 
	  
	  gzak <- ggplot(subset(allstreams.zakojska.df,Mark!="NA" & Cohort!="P"), aes(x = Age, y = Length)) 	  
gzak1 <- gzak + geom_line(aes(group = Mark), lwd = line.lwd ,colour=col.line) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
  #    ggtitle("Zakojska") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,200,300,400),limits=c(80, 440)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9,10),limits=c(0, 10)) +
	  labs(x = "Age") +
         labs(y = "Length (mm)") 


arrange_ggplot2(gggat.timesamp,ggat1,ggzak.timesamp,gzak1,ncol = 2)
##1000 500
	  
	  
	  


