## define some aesthetics 

size.label.x = 25
size.text.x = 15

size.label.y = 25
size.text.y = 15
size.legend.text = 15
size.legend.title = 15
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3
line.lwd = 2

##### plot for Zakojska cohorts
 

data = m_grow3_zak_Linfcohort_kcohort.par   ### get model parameters for the model with cohort as 
# predictor of both Linf and k

n.tot.coh = length(data$beta)

predict.growth = data.frame(Age = rep(1:maxage,n.tot.coh),
Length = rep(0,maxage*n.tot.coh), 
Cohort = rep(c(1:n.tot.coh),each = maxage)) 

contlen1 = 1

for (yy in 1:(length(data$beta))) {



if (yy == 1) {

Linf.coh = data$beta[1]
k.coh = data$beta_k0[1]

}

else {

Linf.coh = data$beta[1] + data$beta[yy]
k.coh = data$beta_k0[1] + data$beta_k0[yy]
}


plot.predict =VBsnov3(Linf.coh,k.coh,log_sigma_v,0,log_sigma_u,
0,beta_t0, log_sigma_w,0, 2,maxage=maxage)

contsim = sum(predict.growth$Sim<j)

predict.growth$Length[contlen1:((maxage*yy)+contsim)] = plot.predict$Length


contlen1 = length(predict.growth$Length[predict.growth$Length>0])+1

}



## plot in RStudio with width of 1500, height 650


gzak.allcoh <- ggplot(subset(predict.growth), aes(x = Age, y = Length)) 
 

gzak.allcoh1 <- gzak.allcoh + geom_line(aes(group = Cohort),col="gray40",lwd = 1) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
       ggtitle("") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(80, 400)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8),limits=c(0, 8)) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=20,vjust=-2),
           axis.text.x  = element_text(size=16),
           axis.title.y = element_text(size=20, vjust = 0.1),
           axis.text.y  = element_text(size=16)) +
           ylab("Length (mm)")
	  
#gzak.allcoh1
	  
	    
## Gacnik
 

data = m_grow3_gat_Linfcohort_kcohort.par 

n.tot.coh = length(data$beta)

predict.growth = data.frame(Age = rep(1:maxage,n.tot.coh),
Length = rep(0,maxage*n.tot.coh), 
Cohort = rep(c(1:n.tot.coh),each = maxage)) 

contlen1 = 1

for (yy in 1:(length(data$beta))) {



if (yy == 1) {

Linf.coh = data$beta[1]
k.coh = data$beta_k0[1]

}

else {

Linf.coh = data$beta[1] + data$beta[yy]
k.coh = data$beta_k0[1] + data$beta_k0[yy]
}


plot.predict =VBsnov3(Linf.coh,k.coh,log_sigma_v,0,log_sigma_u,
0,beta_t0, log_sigma_w,0, 2,maxage=maxage)

contsim = sum(predict.growth$Sim<j)

predict.growth$Length[contlen1:((maxage*yy)+contsim)] = plot.predict$Length


contlen1 = length(predict.growth$Length[predict.growth$Length>0])+1

}



## plot in RStudio with width of 1500, height 650


ggat.allcoh <- ggplot(subset(predict.growth), aes(x = Age, y = Length)) 

#g <- ggplot(subset(uppidri.df,Mark!="NA" & Month == 9), aes(x = Age, y = Weight)) 

ggat.allcoh1 <- ggat.allcoh + geom_line(aes(group = Cohort),col="gray40",lwd = 1) +
      #geom_smooth(aes(group = 1), colour = 'red', size = 1) +
       ggtitle("") +
      theme(plot.title = element_text(lineheight=.8, face="bold",size = 25),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(80, 400)) +
	  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8),limits=c(0, 8)) +
	   theme(plot.margin = unit(c(2,1,2,1), "cm"),
	   axis.title.x = element_text(size=20,vjust=-2),
           axis.text.x  = element_text(size=16),
           axis.title.y = element_text(size=20, vjust = 0.1),
           axis.text.y  = element_text(size=16)) +
            ylab("")
	  
#ggat.allcoh1 	


### plot the two plots together

arrange_ggplot2(gzak.allcoh1,ggat.allcoh1,ncol=2)
