source("ADMButils.s")
require(MASS)
require(lattice)
## Function for arranging ggplots. use png(); arrange(p1, p2, ncol=1); dev.off() to save.
require(grid)
vp.layout <- function(x, y) viewport(layout.pos.row=x, layout.pos.col=y)
arrange_ggplot2 <- function(..., nrow=NULL, ncol=NULL, as.table=FALSE) {
	dots <- list(...)
	n <- length(dots)
	if(is.null(nrow) & is.null(ncol)) { nrow = floor(n/2) ; ncol = ceiling(n/nrow)}
	if(is.null(nrow)) { nrow = ceiling(n/ncol)}
	if(is.null(ncol)) { ncol = ceiling(n/nrow)}
        ## NOTE see n2mfrow in grDevices for possible alternative
grid.newpage()
pushViewport(viewport(layout=grid.layout(nrow,ncol) ) )
	ii.p <- 1
	for(ii.row in seq(1, nrow)){
	ii.table.row <- ii.row	
	if(as.table) {ii.table.row <- nrow - ii.table.row + 1}
		for(ii.col in seq(1, ncol)){
			ii.table <- ii.p
			if(ii.p > n) break
			print(dots[[ii.table]], vp=vp.layout(ii.table.row, ii.col))
			ii.p <- ii.p + 1
		}
	}
}
         


size.label.x = 25
size.text.x = 15

size.label.y = 25
size.text.y = 15
size.legend.text = 15
size.legend.title = 15
unit.legend.h = 1.4
unit.legend.w = 1.4
size.point = 3

options(digits=2)
results.par = m_grow3_zak_Linfcohort_kcohort.par
data = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C11")
data$Cohort=factor(data$Cohort)
unique.mark = unique(data$Mark)
allstreams.zakojska.nop.df$Cohort = factor(allstreams.zakojska.nop.df$Cohort)
Linf = rep(0,length(unique.mark))
k = rep(0,length(unique.mark))
for (i in 1:length(unique.mark)) {

cohort_mark = data[data$Mark == unique.mark[i],"Cohort"]

cohort_mark = as.numeric(cohort_mark[1])

if (cohort_mark ==1) {

Linf[i] = exp(results.par$beta[1]*10 + exp(results.par$log_sigma_v)*results.par$v[i])
k[i] = exp(results.par$beta_k0[1])* exp(exp(results.par$log_sigma_u)*results.par$u[i])
}

else {

Linf[i] = exp((results.par$beta[1] + results.par$beta[cohort_mark])*10 + 
exp(results.par$log_sigma_v)*results.par$v[i])
k[i] = exp(results.par$beta_k0[1] + results.par$beta_k0[cohort_mark]) * 
exp( exp(results.par$log_sigma_u)*results.par$u[i])
}

}	

#k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u )
#Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)


randeff = data.frame(randeff = c(results.par$u,results.par$v), 
variable = c(rep('u',length(results.par$u)),rep('v',length(results.par$v))))
klinf = data.frame(k = k, linf = Linf) 


require(ggplot2)
require(grid)
label.v = bquote(paste(italic(L)[infinity]," (mm)"))
label.u = bquote(paste(italic(k)," (",y^-1,")")) 


ggzakdensity = ggplot(randeff, aes(randeff, fill = variable)) +
geom_density(alpha = 0.3, col="black",lwd = 1.2) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous() +
	  scale_x_continuous() +
	  scale_fill_manual(values=c("gray10", "gray60"),labels = c("u","v")) +
	   theme(plot.margin = unit(c(1,1,1,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
           labs(x = "Individual random effect") +
           labs(y = "Density") +
           labs(fill = "RE")
           
ggzakpoints = ggplot(klinf, aes(linf,k)) + geom_point(size = size.point) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous() +
	  scale_x_continuous() +
	   theme(plot.margin = unit(c(1,1,1,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
           labs(x = label.v) +
           labs(y = label.u) 
         



results.par = m_grow3_gat_Linfcohort_kcohort.par
data = subset(allstreams.gatsnik.df, Cohort!="P" & Cohort!="C11")
data$Cohort=factor(data$Cohort)
unique.mark = unique(data$Mark)
Linf = rep(0,length(unique.mark))
k = rep(0,length(unique.mark))
for (i in 1:length(unique.mark)) {

cohort_mark = data[data$Mark == unique.mark[i],"Cohort"]

cohort_mark = as.numeric(cohort_mark[1])

if (cohort_mark ==1) {

Linf[i] = exp(results.par$beta[1]*10 + exp(results.par$log_sigma_v)*results.par$v[i])
k[i] = exp(results.par$beta_k0[1])* exp(exp(results.par$log_sigma_u)*results.par$u[i])
}

else {

Linf[i] = exp((results.par$beta[1] + results.par$beta[cohort_mark])*10 + 
exp(results.par$log_sigma_v)*results.par$v[i])
k[i] = exp(results.par$beta_k0[1] + results.par$beta_k0[cohort_mark]) * 
exp( exp(results.par$log_sigma_u)*results.par$u[i])
}

}	

#k = exp(results.par$beta_k0) * exp( exp(results.par$log_sigma_u)*results.par$u )
#Linf = exp(results.par$beta*10 + exp(results.par$log_sigma_v)*results.par$v)


randeff = data.frame(randeff = c(results.par$u,results.par$v), 
variable = c(rep('u',length(results.par$u)),rep('v',length(results.par$v))))
klinf = data.frame(k = k, linf = Linf) 


require(ggplot2)
require(grid)


gggatdensity = ggplot(randeff, aes(randeff, fill = variable)) +
geom_density(alpha = 0.3, col="black",lwd = 1.2) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous() +
	  scale_x_continuous() +
	  scale_fill_manual(values=c("gray10", "gray60"),labels = c("u","v")) +
	   theme(plot.margin = unit(c(1,1,1,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
           labs(x = "Individual random effect") +
           labs(y = "Density") +
           labs(fill = "RE")
           
gggatpoints = ggplot(klinf, aes(linf,k)) + geom_point(size = size.point) +
theme(plot.title = element_text(lineheight=.8, face="bold",size = 35),
    plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank()) +theme(axis.line = element_line(color = 'black')) +
      scale_y_continuous() +
	  scale_x_continuous() +
	   theme(plot.margin = unit(c(1,1,1,1), "cm"),
	   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
           labs(x = label.v) +
           labs(y = label.u) 
           
           
           
         

arrange_ggplot2(ggzakdensity,ggzakpoints,gggatdensity,gggatpoints)


  