require(ggplot2)
require(grid)



 
#seed 42, you need the file results.par.Linf.c.k.c.gat42
results.par.Linf.c.k.c.gat42 = readRDS("results.par.Linf.c.k.c.gat42.RDS")

# In RStudio I plot with Width = 1000, Height = 500

seed = 42
set.seed(seed)

allstreams.gatsnik.cohort.df = subset(allstreams.gatsnik.df, Cohort!="P" & Cohort!="C11")

allstreams.gatsnik.cohort.df$Cohort = factor(allstreams.gatsnik.cohort.df$Cohort)

marktable.gat = with(allstreams.gatsnik.cohort.df,table(Mark)) 

samplemark.gat = (sample(marktable.gat[marktable.gat>=4],150)) #total number of sampled more than 3 times is 450


exclmar.gat = as.numeric(rownames(samplemark.gat))
 
data = allstreams.gatsnik.cohort.df

markd.gat = subset(data,Mark %in% exclmar.gat)

obsmiss.gat = data.frame(Mark=rep(0,10*length(exclmar.gat)),Age = rep(0,10*length(exclmar.gat)) ,
 Obs = rep(0,10*length(exclmar.gat)),Cohort = rep(0,10*length(exclmar.gat)))

missrow.gat = matrix(0,10*length(exclmar.gat),1)




vectincl = c(1)

nrowdp = rep(0,length(exclmar.gat))
for (i in 1:length(exclmar.gat)) {

dataprov= 0
dataprov = subset(markd.gat,Mark == exclmar.gat[i])
vectexcl = seq(1,nrow(dataprov),1)[-vectincl]
contlen = length(missrow.gat[missrow.gat>0])
nrowdp[i] = nrow(dataprov)-length(vectincl)
missrow.gat[(contlen+1):(contlen + nrowdp[i])] = which(data[,"Mark"] == exclmar.gat[i])[vectexcl]



obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Mark"] = dataprov$Mark[vectexcl]
obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Age"] = dataprov$Age[vectexcl]
obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Obs"] = dataprov$Length[vectexcl]
obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Cohort"] = dataprov$Cohort[vectexcl]
}
obsmiss.gat = obsmiss.gat[obsmiss.gat$Mark>0,]
missrow.gat = missrow.gat[missrow.gat>0]


allstreams.gatsnik.miss.df = allstreams.gatsnik.cohort.df[-c(missrow.gat),]


results.par = get(paste("results.par.Linf.c.k.c.gat",seed,sep=""))

markuv.gat = data.frame(Mark = unique(allstreams.gatsnik.miss.df$Mark), u = results.par$u,v = results.par$v)

valid.gat=rep(0,4500)

for (i in 1:length(exclmar.gat)) {

cohort_mark = allstreams.gatsnik.cohort.df[allstreams.gatsnik.cohort.df$Mark == exclmar.gat[i],"Cohort"]

cohort_mark = as.numeric(cohort_mark[1])

if (cohort_mark ==1) {

Linf = results.par$beta[1] 
k = results.par$beta_k0[1]
}

else {

Linf = results.par$beta[1] + results.par$beta[cohort_mark] 
k = results.par$beta_k0[1] + results.par$beta_k0[cohort_mark] 
}

plot.gat =VBsnov(Linf,k,results.par$log_sigma_v,markuv.gat[markuv.gat$Mark==exclmar.gat[i],"v"],results.par$log_sigma_u,
markuv.gat[markuv.gat$Mark==exclmar.gat[i],"u"],results.par$beta_t0,2,maxage=14)

contlen = length(valid.gat[valid.gat>0])

nrowmiss = nrow(subset(obsmiss.gat,Mark==exclmar.gat[i]))

valid.gat[(contlen+1):(contlen+nrowmiss)] = 
plot.gat[plot.gat$Age %in% obsmiss.gat[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid.gat = valid.gat[valid.gat>0]
obsmiss.gat$Pred = valid.gat


SSE.pred = sum((obsmiss.gat$Obs-obsmiss.gat$Pred)^2)
SST.pred = sum((obsmiss.gat$Obs-mean(obsmiss.gat$Obs))^2)
Rsq.pred = 1-(SSE.pred/SST.pred)

mean.err.pred = sqrt(mean((obsmiss.gat$Obs-obsmiss.gat$Pred)^2))


for (i in 1:nrow(obsmiss.gat)) {
obsmiss.gat$length.avg[i] = with(subset(allstreams.gatsnik.cohort.df,Age==obsmiss.gat$Age[i] & 
Cohort == levels(allstreams.gatsnik.cohort.df$Cohort)[obsmiss.gat$Cohort[i]]),mean(Length))
}
#plot(Obs ~ length.avg, data=obsmiss.gat,main="Keep just the first observation")



SSE.avg = sum((obsmiss.gat$Obs-obsmiss.gat$length.avg)^2)
SST.avg = sum((obsmiss.gat$Obs-mean(obsmiss.gat$Obs))^2)
Rsq.avg = 1-(SSE.avg/SST.avg)

mean.err.avg = sqrt(mean((obsmiss.gat$Obs-obsmiss.gat$length.avg)^2))
size.label.x = 25
size.text.x = 20
size.point = 5
size.label.y = 25
size.text.y = 20
size.legend.text = 15
size.legend.title = 15
unit.legend.h = 1.4
unit.legend.w = 1.4


ggat <- ggplot(subset(obsmiss.gat), aes(x = Pred, y = Obs)) 	  
ggat.modpred  <- ggat + geom_point(pch = 16, size = 5) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("mediantimesnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(120, 420)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(120, 420)) +
	  labs(y = "Observed length (mm)") +
           labs(x = "Predicted length (mm)") 
           
    ggat <- ggplot(subset(obsmiss.gat), aes(x = length.avg, y = Obs)) 	  
ggat.avgpred  <- ggat + geom_point(pch = 1, size = 5,lwd =8) +
coord_fixed() +
geom_abline(intercept=0, slope=1, linetype = 2, lwd=1.2) +
 #      ggtitle("mediantimesnik") +
      theme(plot.title = element_text(lineheight=.8, face="bold"), 
      plot.background = element_blank()
   ,panel.grid.major = element_blank()
   ,panel.grid.minor = element_blank()
   ,panel.border = element_blank()
   ,panel.background = element_blank(),
   axis.line = element_line(color = 'black'),
   plot.margin = unit(c(1.5,1.5,1.5,1.5), "cm"),
   axis.title.x = element_text(size=size.label.x,vjust=-2),
           axis.text.x  = element_text(size=size.text.x ),
           axis.title.y = element_text(size=size.label.y, vjust = 0.1),
           axis.text.y  = element_text(size=size.text.y),
           legend.text=element_text(size=size.legend.text,vjust = -30),
           legend.title=element_text(size=size.legend.title,vjust = -30),
           legend.key.height=unit(unit.legend.h ,"line"),
           legend.key.width=unit(unit.legend.w,"line")) +
      scale_y_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(120, 420)) +
	  scale_x_continuous(breaks=c(100,150,200,250,300,350,400),limits=c(120, 420)) +
	  labs(x = "Predicted length (mm)") +
	  labs(y = "")
           

           
arrange_ggplot2(ggat.modpred,ggat.avgpred,ncol = 2)