source("ADMButils.s") ## source set to tools for getting data generated by admb into r

##before running the models, compile m_grow3.tpl in the shell in the folder you are in
# by admb -r m_grow3

source("m_grow3_gat0_noP.r")  #model with no predictors
system("./m_grow3 -est")  ##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat0_noP.par = par_read("m_grow3.par") #read the .par file produced
m_grow3_gat0_noP.rep = scan("m_grow3.rep") #read the .rep file produced

source("m_grow3_gat_Linfdensity.r") #model with density as predictors for both Lin and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfdensity.par = par_read("m_grow3.par")
m_grow3_gat_Linfdensity.rep = scan("m_grow3.rep")

source("m_grow3_gat_Linfdensity_kcohort.r")#model with density as predictor Linf 
#and cohort for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfdensity_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_Linfdensity_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced


source("m_grow3_gat_kcohort.r") #model with cohort as predictor for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_gat_kdensity.r") #model with density as predictor for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_gat_Linfcohort_kdensity.r")#model with cohort as predictor Linf 
#and density for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfcohort_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_Linfcohort_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_gat_Linfcohort.r")#model with cohort as predictor for Linf
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_Linfcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_gat_Linfcohort_kcohort.r")#model with cohort as predictor for Linf and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfcohort_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_Linfcohort_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_gat_Linfdensity_kdensity.r")#model with density as predictor for Linf and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_gat_Linfdensity_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_gat_Linfdensity_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced



###save as RDS the objects created (.par and .rep files)
saveRDS(m_grow3_gat0_noP.par,"m_grow3_gat0_noP.par.RDS")
saveRDS(m_grow3_gat0_noP.rep,"m_grow3_gat0_noP.rep.RDS")

saveRDS(m_grow3_gat_Linfdensity.par,"m_grow3_gat_Linfdensity.par.RDS")
saveRDS(m_grow3_gat_Linfdensity.rep,"m_grow3_gat_Linfdensity.rep.RDS")

saveRDS(m_grow3_gat_Linfdensity_kcohort.par,"m_grow3_gat_Linfdensity_kcohort.par.RDS")
saveRDS(m_grow3_gat_Linfdensity_kcohort.rep,"m_grow3_gat_Linfdensity_kcohort.rep.RDS")

saveRDS(m_grow3_gat_kcohort.par,"m_grow3_gat_kcohort.par.RDS")
saveRDS(m_grow3_gat_kcohort.rep,"m_grow3_gat_kcohort.rep.RDS")


saveRDS(m_grow3_gat_kdensity.par,"m_grow3_gat_kdensity.par.RDS")
saveRDS(m_grow3_gat_kdensity.rep,"m_grow3_gat_kdensity.rep.RDS")

saveRDS(m_grow3_gat_Linfcohort_kdensity.par,"m_grow3_gat_Linfcohort_kdensity.par.RDS")
saveRDS(m_grow3_gat_Linfcohort_kdensity.rep,"m_grow3_gat_Linfcohort_kdensity.rep.RDS")

saveRDS(m_grow3_gat_Linfcohort.par,"m_grow3_gat_Linfcohort.par.RDS")
saveRDS(m_grow3_gat_Linfcohort.rep,"m_grow3_gat_Linfcohort.rep.RDS")

saveRDS(m_grow3_gat_Linfcohort_kcohort.par,"m_grow3_gat_Linfcohort_kcohort.par.RDS")
saveRDS(m_grow3_gat_Linfcohort_kcohort.rep,"m_grow3_gat_Linfcohort_kcohort.rep.RDS")

saveRDS(m_grow3_gat_Linfdensity_kdensity.par,"m_grow3_gat_Linfdensity_kdensity.par.RDS")
saveRDS(m_grow3_gat_Linfdensity_kdensity.rep,"m_grow3_gat_Linfdensity_kdensity.rep.RDS")


############  read the data (not really needed) #####
m_grow3_gat0_noP.par = readRDS("m_grow3_gat0_noP.par.RDS")
m_grow3_gat0_noP.rep = readRDS("m_grow3_gat0_noP.rep.RDS")

m_grow3_gat_Linfdensity.par = readRDS("m_grow3_gat_Linfdensity.par.RDS")
m_grow3_gat_Linfdensity.rep = readRDS("m_grow3_gat_Linfdensity.rep.RDS")

m_grow3_gat_Linfdensity_kcohort.par = readRDS("m_grow3_gat_Linfdensity_kcohort.par.RDS")
m_grow3_gat_Linfdensity_kcohort.rep = readRDS("m_grow3_gat_Linfdensity_kcohort.rep.RDS")

m_grow3_gat_kcohort.par = readRDS("m_grow3_gat_kcohort.par.RDS")
m_grow3_gat_kcohort.rep = readRDS("m_grow3_gat_kcohort.rep.RDS")


m_grow3_gat_kdensity.par = readRDS("m_grow3_gat_kdensity.par.RDS")
m_grow3_gat_kdensity.rep = readRDS("m_grow3_gat_kdensity.rep.RDS")

m_grow3_gat_Linfcohort_kdensity.par = readRDS("m_grow3_gat_Linfcohort_kdensity.par.RDS")
m_grow3_gat_Linfcohort_kdensity.rep = readRDS("m_grow3_gat_Linfcohort_kdensity.rep.RDS")

m_grow3_gat_Linfcohort.par = readRDS("m_grow3_gat_Linfcohort.par.RDS")
m_grow3_gat_Linfcohort.rep = readRDS("m_grow3_gat_Linfcohort.rep.RDS")

m_grow3_gat_Linfcohort_kcohort.par = readRDS("m_grow3_gat_Linfcohort_kcohort.par.RDS")
m_grow3_gat_Linfcohort_kcohort.rep = readRDS("m_grow3_gat_Linfcohort_kcohort.rep.RDS")

m_grow3_gat_Linfdensity_kdensity.par = readRDS("m_grow3_gat_Linfdensity_kdensity.par.RDS")
m_grow3_gat_Linfdensity_kdensity.rep = readRDS("m_grow3_gat_Linfdensity_kdensity.rep.RDS")





#######report gradient of model (it has to be negative if the algo converged)
##calculate AIC for each model. There is (-) before number of parameters because there is 
#a bug in ADMBultils (number of parameters comes out negative)
#There are also a couple of examples for BIC ###


m_grow3_gat0_noP.par$gradient
m_grow3_gat0_noP.AIC = -2*m_grow3_gat0_noP.par$n_par - 2*m_grow3_gat0_noP.par$loglik
m_grow3_gat_Linfdensity.par$gradient
m_grow3_gat_Linfdensity.AIC = -2*m_grow3_gat_Linfdensity.par$n_par - 2*m_grow3_gat_Linfdensity.par$loglik
m_grow3_gat_Linfdensity_kcohort.par$gradient
m_grow3_gat_Linfdensity_kcohort.AIC = -2*m_grow3_gat_Linfdensity_kcohort.par$n_par - 2*m_grow3_gat_Linfdensity_kcohort.par$loglik
m_grow3_gat_kcohort.par$gradient
m_grow3_gat_kcohort.AIC = -2*m_grow3_gat_kcohort.par$n_par - 2*m_grow3_gat_kcohort.par$loglik
m_grow3_gat_kcohort.par.BIC = -m_grow3_gat_kcohort.par$n_par*
log(length(m_grow3_gat_kcohort.par$u)) - 2*m_grow3_gat_kcohort.par$loglik
m_grow3_gat_kdensity.par$gradient
m_grow3_gat_kdensity.AIC = -2*m_grow3_gat_kdensity.par$n_par - 2*m_grow3_gat_kdensity.par$loglik
m_grow3_gat_Linfcohort_kdensity.par$gradient
m_grow3_gat_Linfcohort_kdensity.AIC = -2*m_grow3_gat_Linfcohort_kdensity.par$n_par - 2*m_grow3_gat_Linfcohort_kdensity.par$loglik
m_grow3_gat_Linfcohort.par$gradient
m_grow3_gat_Linfcohort.AIC = -2*m_grow3_gat_Linfcohort.par$n_par - 2*m_grow3_gat_Linfcohort.par$loglik
m_grow3_gat_Linfcohort_kcohort.par$gradient
m_grow3_gat_Linfcohort_kcohort.AIC = -2*m_grow3_gat_Linfcohort_kcohort.par$n_par - 2*m_grow3_gat_Linfcohort_kcohort.par$loglik
m_grow3_gat_Linfcohort_kcohort.BIC = -m_grow3_gat_Linfcohort_kcohort.par$n_par*
log(length(m_grow3_gat_Linfcohort_kcohort.par$u)) - 2*m_grow3_gat_Linfcohort_kcohort.par$loglik
m_grow3_gat_Linfdensity_kdensity.par$gradient
m_grow3_gat_Linfdensity_kdensity.AIC = -2*m_grow3_gat_Linfdensity_kdensity.par$n_par - 2*m_grow3_gat_Linfdensity_kdensity.par$loglik


###print out the AIC values #####
m_grow3_gat0_noP.AIC
m_grow3_gat_Linfdensity.AIC
m_grow3_gat_Linfdensity_kcohort.AIC
m_grow3_gat_kcohort.AIC 
m_grow3_gat_kdensity.AIC
m_grow3_gat_Linfcohort_kdensity.AIC
m_grow3_gat_Linfcohort.AIC 
m_grow3_gat_Linfcohort_kcohort.AIC
m_grow3_gat_Linfdensity_kdensity.AIC


##### I do the same thing for the population of Zakojska ####



source("m_grow3_zak0_noP.r")#model with no predictors
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak0_noP.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak0_noP.rep = scan("m_grow3.rep") #read the .rep file produced

source("m_grow3_zak_Linfdensity.r")#model with density as predictors for both Lin and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfdensity.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_Linfdensity_kcohort.r")#model with density as predictor Linf 
#and cohort for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfdensity_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfdensity_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced


source("m_grow3_zak_kcohort.r")#model with cohort as predictor for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_kdensity.r")#model with density as predictor for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_Linfcohort_kdensity.r")#model with cohort as predictor Linf 
#and density for k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfcohort_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_Linfcohort.r")#model with cohort as predictor for Linf
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_Linfcohort_kcohort.r")#model with cohort as predictor for Linf and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfcohort_kcohort.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfcohort_kcohort.rep = scan("m_grow3.rep")#read the .rep file produced

source("m_grow3_zak_Linfdensity_kdensity.r")#model with density as predictor for Linf and k
system("./m_grow3 -est")##run model (-est means that standard errors of estimates are 
#not estimated)
m_grow3_zak_Linfdensity_kdensity.par = par_read("m_grow3.par")#read the .par file produced
m_grow3_zak_Linfdensity_kdensity.rep = scan("m_grow3.rep")#read the .rep file produced


###save as RDS the objects created (.par and .rep files)
saveRDS(m_grow3_zak0_noP.par,"m_grow3_zak0_noP.par.RDS")
saveRDS(m_grow3_zak0_noP.rep,"m_grow3_zak0_noP.rep.RDS")

saveRDS(m_grow3_zak_Linfdensity.par,"m_grow3_zak_Linfdensity.par.RDS")
saveRDS(m_grow3_zak_Linfdensity.rep,"m_grow3_zak_Linfdensity.rep.RDS")

saveRDS(m_grow3_zak_Linfdensity_kcohort.par,"m_grow3_zak_Linfdensity_kcohort.par.RDS")
saveRDS(m_grow3_zak_Linfdensity_kcohort.rep,"m_grow3_zak_Linfdensity_kcohort.rep.RDS")

saveRDS(m_grow3_zak_kcohort.par,"m_grow3_zak_kcohort.par.RDS")
saveRDS(m_grow3_zak_kcohort.rep,"m_grow3_zak_kcohort.rep.RDS")


saveRDS(m_grow3_zak_kdensity.par,"m_grow3_zak_kdensity.par.RDS")
saveRDS(m_grow3_zak_kdensity.rep,"m_grow3_zak_kdensity.rep.RDS")

saveRDS(m_grow3_zak_Linfcohort_kdensity.par,"m_grow3_zak_Linfcohort_kdensity.par.RDS")
saveRDS(m_grow3_zak_Linfcohort_kdensity.rep,"m_grow3_zak_Linfcohort_kdensity.rep.RDS")

saveRDS(m_grow3_zak_Linfcohort.par,"m_grow3_zak_Linfcohort.par.RDS")
saveRDS(m_grow3_zak_Linfcohort.rep,"m_grow3_zak_Linfcohort.rep.RDS")

saveRDS(m_grow3_zak_Linfcohort_kcohort.par,"m_grow3_zak_Linfcohort_kcohort.par.RDS")
saveRDS(m_grow3_zak_Linfcohort_kcohort.rep,"m_grow3_zak_Linfcohort_kcohort.rep.RDS")

saveRDS(m_grow3_zak_Linfdensity_kdensity.par,"m_grow3_zak_Linfdensity_kdensity.par.RDS")
saveRDS(m_grow3_zak_Linfdensity_kdensity.rep,"m_grow3_zak_Linfdensity_kdensity.rep.RDS")

#######report gradient of model (it has to be negative if the algo converged)
##calculate AIC for each model. There is (-) before number of parameters because there is 
#a bug in ADMBultils (number of parameters comes out negative)
#There are also a couple of examples for BIC ###

m_grow3_zak0_noP.par$gradient
m_grow3_zak0_noP.AIC = -2*m_grow3_zak0_noP.par$n_par - 2*m_grow3_zak0_noP.par$loglik
m_grow3_zak_Linfdensity.par$gradient
m_grow3_zak_Linfdensity.AIC = -2*m_grow3_zak_Linfdensity.par$n_par - 2*m_grow3_zak_Linfdensity.par$loglik
m_grow3_zak_Linfdensity_kcohort.par$gradient
m_grow3_zak_Linfdensity_kcohort.AIC = -2*m_grow3_zak_Linfdensity_kcohort.par$n_par - 2*m_grow3_zak_Linfdensity_kcohort.par$loglik
m_grow3_zak_kcohort.par$gradient
m_grow3_zak_kcohort.AIC = -2*m_grow3_zak_kcohort.par$n_par - 2*m_grow3_zak_kcohort.par$loglik
m_grow3_zak_kdensity.par$gradient
m_grow3_zak_kdensity.AIC = -2*m_grow3_zak_kdensity.par$n_par - 2*m_grow3_zak_kdensity.par$loglik
m_grow3_zak_Linfcohort_kdensity.par$gradient
m_grow3_zak_Linfcohort_kdensity.AIC = -2*m_grow3_zak_Linfcohort_kdensity.par$n_par - 2*m_grow3_zak_Linfcohort_kdensity.par$loglik
m_grow3_zak_Linfcohort.par$gradient
m_grow3_zak_Linfcohort.AIC = -2*m_grow3_zak_Linfcohort.par$n_par - 2*m_grow3_zak_Linfcohort.par$loglik
m_grow3_zak_Linfcohort_kcohort.par$gradient
m_grow3_zak_Linfcohort_kcohort.AIC = -2*m_grow3_zak_Linfcohort_kcohort.par$n_par - 2*m_grow3_zak_Linfcohort_kcohort.par$loglik
m_grow3_zak_Linfdensity_kdensity.par$gradient
m_grow3_zak_Linfdensity_kdensity.AIC = -2*m_grow3_zak_Linfdensity_kdensity.par$n_par - 2*m_grow3_zak_Linfdensity_kdensity.par$loglik


###print out the AIC values #####
m_grow3_zak0_noP.AIC
m_grow3_zak_Linfdensity.AIC
m_grow3_zak_Linfdensity_kcohort.AIC
m_grow3_zak_kcohort.AIC 
m_grow3_zak_kdensity.AIC
m_grow3_zak_Linfcohort_kdensity.AIC
m_grow3_zak_Linfcohort.AIC 
m_grow3_zak_Linfcohort_kcohort.AIC
m_grow3_zak_Linfdensity_kdensity.AIC


