# Sets up the data in R

library(R2admb)

dd = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C11")

dd$Cohort = factor(dd$Cohort)


form0.linf.zak.formula =  ~ 1
form1.k.zak.formula = ~ 1
form1.t0.zak.formula = ~ 1

mod0.linf.zak.miss.mm = model.matrix(form0.linf.zak.formula,data=dd)
mod1.k.zak.miss.mm = model.matrix(form1.k.zak.formula,data=dd)
mod1.t0.zak.miss.mm = model.matrix(form1.t0.zak.formula,data = dd)





X = mod0.linf.zak.miss.mm
#X[,2]=X[,2]/1000
X_k0 = mod1.k.zak.miss.mm
#X_k0[,2] = X_k0[,2]/1000 
X_t0 = mod1.t0.zak.miss.mm

#X=X[,c(1,20)]
#X_k0=as.matrix(X_k0[,1])

diffmark  = diff(dd$Mark)
diffmark  = ifelse(diffmark==0,0,1)



write_dat("m_grow3",list(n=nrow(dd),
		length=dd$Length,
		age=dd$Age,
                total_marks=length(unique(dd$Mark)),
		start=c(1,which(diffmark>0)+1),
		stop=c(which(diffmark>0),nrow(dd)),
		q=ncol(X),
		X=X,
		q_k0=ncol(X_k0),
		X_k0=X_k0,
		q_t0=ncol(X_t0),
X_t0=X_t0,check=12345))

system("./m_grow3")

