seed.series = c(41:61)

Rsq.pred.vect = rep(0,length(seed.series))
Rsq.avg.vect = rep(0,length(seed.series))
MAE.pred.vect = rep(0,length(seed.series))
MAE.avg.vect = rep(0,length(seed.series))

for (j in 1:length(seed.series)) {

seed = seed.series[j]

set.seed(seed)

allstreams.gatsnik.nop.df = subset(allstreams.gatsnik.df, Cohort!="P" & Cohort!="C11")

allstreams.gatsnik.nop.df$Cohort = factor(allstreams.gatsnik.nop.df$Cohort)

marktable.gat = with(allstreams.gatsnik.nop.df,table(Mark)) 

samplemark.gat = (sample(marktable.gat[marktable.gat>=4],150)) #total number of sampled more than 3 times is 450

exclmar.gat = as.numeric(rownames(samplemark.gat))
 
data = allstreams.gatsnik.nop.df 

markd.gat = subset(data,Mark %in% exclmar.gat)

obsmiss.gat = data.frame(Mark=rep(0,10*length(exclmar.gat)),Age = rep(0,10*length(exclmar.gat)) ,
 Obs = rep(0,10*length(exclmar.gat)))

missrow.gat = matrix(0,10*length(exclmar.gat),1)




vectincl = c(1)

nrowdp = rep(0,length(exclmar.gat))
for (i in 1:length(exclmar.gat)) {

dataprov = 0
dataprov = subset(markd.gat,Mark == exclmar.gat[i])
vectexcl = seq(1,nrow(dataprov),1)[-vectincl]
contlen = length(missrow.gat[missrow.gat>0])
nrowdp[i] = nrow(dataprov)-length(vectincl)
missrow.gat[(contlen+1):(contlen + nrowdp[i])] = which(data[,"Mark"] == exclmar.gat[i])[vectexcl]



obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Mark"] = dataprov$Mark[vectexcl]
obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Age"] = dataprov$Age[vectexcl]
obsmiss.gat[(contlen+1):(contlen + nrowdp[i]),"Obs"] = dataprov$Length[vectexcl]

}
obsmiss.gat = obsmiss.gat[obsmiss.gat$Mark>0,]
missrow.gat = missrow.gat[missrow.gat>0]


allstreams.gatsnik.miss.df = allstreams.gatsnik.nop.df[-c(missrow.gat),]

source("m_grow3_miss_gat0.r")
system("./m_grow3")

#######################



results.par = par_read("m_grow3.par")

assign(paste("results.par.gat0",seed,sep=""), results.par)

pred = read.table("m_grow3.rep")

assign(paste("results.rep.gat0",seed,sep=""), pred)

#pred.df = data.frame(Length=allstreams.gatsnik.miss.df$Length,Pred=pred,Mark=allstreams.gatsnik.miss.df$Mark,Age=allstreams.gatsnik.miss.df$Age)


markuv.gat = data.frame(Mark = unique(allstreams.gatsnik.miss.df$Mark), u = results.par$u,v = results.par$v)



#mtopl = 986

#plot(Length ~ Age,pred.df[pred.df$Mark == mtopl,],xlim=c(0,10),ylim=c(50,350))

#points(Obs ~ Age,obsmiss.gat[obsmiss.gat$Mar == mtopl,],col="red")

# plot.gat =VBsnov(0.57,-1.04,-2.18,markuv.gat[markuv.gat$Mark==mtopl,"v"],
# -2.68,markuv.gat[markuv.gat$Mark==mtopl,"u"],-0.41,1)

valid.gat=rep(0,4500)

for (i in 1:length(exclmar.gat)) {

plot.gat =VBsnov(results.par$beta,results.par$beta_k0,results.par$log_sigma_v,markuv.gat[markuv.gat$Mark==exclmar.gat[i],"v"],results.par$log_sigma_u,
markuv.gat[markuv.gat$Mark==exclmar.gat[i],"u"],results.par$beta_t0,1,maxage=15)

contlen = length(valid.gat[valid.gat>0])

nrowmiss = nrow(subset(obsmiss.gat,Mark==exclmar.gat[i]))

valid.gat[(contlen+1):(contlen+nrowmiss)] = 
plot.gat[plot.gat$Age %in% obsmiss.gat[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid.gat = valid.gat[valid.gat>0]
obsmiss.gat$Pred = valid.gat


SSE.pred = sum((obsmiss.gat$Obs-obsmiss.gat$Pred)^2)
SST.pred = sum((obsmiss.gat$Obs-mean(obsmiss.gat$Obs))^2)
Rsq.pred = 1-(SSE.pred/SST.pred)

mean.err.pred = sqrt(mean((obsmiss.gat$Obs-obsmiss.gat$Pred)^2))


for (i in 1:nrow(obsmiss.gat)) {
obsmiss.gat$length.avg[i] = with(subset(allstreams.gatsnik.nop.df,Age==obsmiss.gat$Age[i]),mean(Length))
}
#plot(Obs ~ length.avg, data=obsmiss.gat,main="Keep just the first observation")



SSE.avg = sum((obsmiss.gat$Obs-obsmiss.gat$length.avg)^2)
SST.avg = sum((obsmiss.gat$Obs-mean(obsmiss.gat$Obs))^2)
Rsq.avg = 1-(SSE.avg/SST.avg)

mean.err.avg = sqrt(mean((obsmiss.gat$Obs-obsmiss.gat$length.avg)^2))
options(digits=2)

if (length(vectincl)==1) { 

par(mfrow=c(1,2))

plot(Obs ~ Pred, data=obsmiss.gat,xlim=c(120,500),ylim=c(120,500),
xlab = "VB prediction (mm)", ylab = "Observation (mm)", main = "Prediction with VB - keep one obs", cex= 1.5)
abline(0,1,lty=2)
text(200,490,bquote(paste(R^2," = ",.(Rsq.pred))))
text(200,450,bquote(paste(bar(MAE)," = ",.(mean.err.pred)," mm")))
#points(Obs ~ Pred, data=subset(obsmiss.gat,Mark==3903),col="red",cex=1.5,pch=16)
plot(Obs ~ length.avg, data=obsmiss.gat,xlim=c(120,500),ylim=c(120,500),
xlab = "Prediction on age (mm)", ylab = "Observation (mm)", main = "Prediction with age - keep one obs", cex= 1.5)
abline(0,1,lty=2)

text(200,490,bquote(paste(R^2," = ",.(Rsq.avg))))
text(200,450,bquote(paste(bar(MAE)," = ",.(mean.err.avg)," mm")))
text(200,410,bquote(paste("seed = ",.(seed))))


}

Rsq.pred.vect[j]= Rsq.pred 
Rsq.avg.vect[j]= Rsq.avg
MAE.pred.vect[j] = mean.err.pred
MAE.avg.vect[j]= mean.err.avg


}

assign(paste("Rsq.pred.vect.gat0",min(seed.series),max(seed.series),sep=""), Rsq.pred.vect)
assign(paste("Rsq.avg.vect.gat0",min(seed.series),max(seed.series),sep=""), Rsq.avg.vect)
assign(paste("MAE.pred.vect.gat0",min(seed.series),max(seed.series),sep=""), MAE.pred.vect)
assign(paste("MAE.avg.vect.gat0",min(seed.series),max(seed.series),sep=""), MAE.avg.vect)