seed.series = c(41:61)

Rsq.pred.vect = rep(0,length(seed.series))
Rsq.avg.vect = rep(0,length(seed.series))
MAE.pred.vect = rep(0,length(seed.series))
MAE.avg.vect = rep(0,length(seed.series))

for (j in 1:length(seed.series)) {

seed = seed.series[j]

set.seed(seed)

allstreams.zakojska.nop.df = subset(allstreams.zakojska.df, Cohort!="P" & Cohort!="C11")

allstreams.zakojska.nop.df$Cohort = factor(allstreams.zakojska.nop.df$Cohort)

marktable.zak = with(allstreams.zakojska.nop.df,table(Mark)) 

samplemark.zak = (sample(marktable.zak[marktable.zak>=4],20)) #total number is 62 for fish sampled more than 3 t

exclmar.zak = as.numeric(rownames(samplemark.zak))
 
data = allstreams.zakojska.nop.df 

markd.zak = subset(data,Mark %in% exclmar.zak)

obsmiss.zak = data.frame(Mark=rep(0,10*length(exclmar.zak)),Age = rep(0,10*length(exclmar.zak)) ,
 Obs = rep(0,10*length(exclmar.zak)))

missrow.zak = matrix(0,10*length(exclmar.zak),1)




vectincl = c(1)

nrowdp = rep(0,length(exclmar.zak))
for (i in 1:length(exclmar.zak)) {

dataprov = 0
dataprov = subset(markd.zak,Mark == exclmar.zak[i])
vectexcl = seq(1,nrow(dataprov),1)[-vectincl]
contlen = length(missrow.zak[missrow.zak>0])
nrowdp[i] = nrow(dataprov)-length(vectincl)
missrow.zak[(contlen+1):(contlen + nrowdp[i])] = which(data[,"Mark"] == exclmar.zak[i])[vectexcl]



obsmiss.zak[(contlen+1):(contlen + nrowdp[i]),"Mark"] = dataprov$Mark[vectexcl]
obsmiss.zak[(contlen+1):(contlen + nrowdp[i]),"Age"] = dataprov$Age[vectexcl]
obsmiss.zak[(contlen+1):(contlen + nrowdp[i]),"Obs"] = dataprov$Length[vectexcl]

}
obsmiss.zak = obsmiss.zak[obsmiss.zak$Mark>0,]
missrow.zak = missrow.zak[missrow.zak>0]


allstreams.zakojska.miss.df = allstreams.zakojska.nop.df[-c(missrow.zak),]

source("m_grow3_miss_zak0.r")
system("./m_grow3")

#######################


results.par = par_read("m_grow3.par")

assign(paste("results.par.zak0",seed,sep=""), results.par)

pred = read.table("m_grow3.rep")

assign(paste("results.rep.zak0",seed,sep=""), pred)
#pred.df = data.frame(Length=allstreams.zakojska.miss.df$Length,Pred=pred,Mark=allstreams.zakojska.miss.df$Mark,Age=allstreams.zakojska.miss.df$Age)


markuv.zak = data.frame(Mark = unique(allstreams.zakojska.miss.df$Mark), u = results.par$u,v = results.par$v)



#mtopl = 986

#plot(Length ~ Age,pred.df[pred.df$Mark == mtopl,],xlim=c(0,10),ylim=c(50,350))

#points(Obs ~ Age,obsmiss.zak[obsmiss.zak$Mar == mtopl,],col="red")

# plot.zak =VBsnov(0.57,-1.04,-2.18,markuv.zak[markuv.zak$Mark==mtopl,"v"],
# -2.68,markuv.zak[markuv.zak$Mark==mtopl,"u"],-0.41,1)

valid.zak=rep(0,500)

for (i in 1:length(exclmar.zak)) {

plot.zak =VBsnov(results.par$beta,results.par$beta_k0,results.par$log_sigma_v,markuv.zak[markuv.zak$Mark==exclmar.zak[i],"v"],results.par$log_sigma_u,
markuv.zak[markuv.zak$Mark==exclmar.zak[i],"u"],results.par$beta_t0,1)

contlen = length(valid.zak[valid.zak>0])

nrowmiss = nrow(subset(obsmiss.zak,Mark==exclmar.zak[i]))

valid.zak[(contlen+1):(contlen+nrowmiss)] = 
plot.zak[plot.zak$Age %in% obsmiss.zak[(contlen+1):(contlen+nrowmiss),"Age"],"Length"] 

}

valid.zak = valid.zak[valid.zak>0]
obsmiss.zak$Pred = valid.zak


SSE.pred = sum((obsmiss.zak$Obs-obsmiss.zak$Pred)^2)
SST.pred = sum((obsmiss.zak$Obs-mean(obsmiss.zak$Obs))^2)
Rsq.pred = 1-(SSE.pred/SST.pred)

mean.err.pred = sqrt(mean((obsmiss.zak$Obs-obsmiss.zak$Pred)^2))


for (i in 1:nrow(obsmiss.zak)) {
obsmiss.zak$length.avg[i] = with(subset(allstreams.zakojska.nop.df,Age==obsmiss.zak$Age[i]),mean(Length))
}
#plot(Obs ~ length.avg, data=obsmiss.zak,main="Keep just the first observation")



SSE.avg = sum((obsmiss.zak$Obs-obsmiss.zak$length.avg)^2)
SST.avg = sum((obsmiss.zak$Obs-mean(obsmiss.zak$Obs))^2)
Rsq.avg = 1-(SSE.avg/SST.avg)

mean.err.avg = sqrt(mean((obsmiss.zak$Obs-obsmiss.zak$length.avg)^2))
options(digits=2)

if (length(vectincl)==1) { 

par(mfrow=c(1,2))

plot(Obs ~ Pred, data=obsmiss.zak,xlim=c(120,500),ylim=c(120,500),
xlab = "VB prediction (mm)", ylab = "Observation (mm)", main = "Prediction with VB - keep one obs", cex= 1.5)
abline(0,1,lty=2)
text(200,490,bquote(paste(R^2," = ",.(Rsq.pred))))
text(200,450,bquote(paste(bar(MAE)," = ",.(mean.err.pred)," mm")))
#points(Obs ~ Pred, data=subset(obsmiss.zak,Mark==3903),col="red",cex=1.5,pch=16)
plot(Obs ~ length.avg, data=obsmiss.zak,xlim=c(120,500),ylim=c(120,500),
xlab = "Prediction on age (mm)", ylab = "Observation (mm)", main = "Prediction with age - keep one obs", cex= 1.5)
abline(0,1,lty=2)

text(200,490,bquote(paste(R^2," = ",.(Rsq.avg))))
text(200,450,bquote(paste(bar(MAE)," = ",.(mean.err.avg)," mm")))
text(200,410,bquote(paste("seed = ",.(seed))))


}

Rsq.pred.vect[j]= Rsq.pred 
Rsq.avg.vect[j]= Rsq.avg
MAE.pred.vect[j] = mean.err.pred
MAE.avg.vect[j]= mean.err.avg


}

assign(paste("Rsq.pred.vect.zak0",min(seed.series),max(seed.series),sep=""), Rsq.pred.vect)
assign(paste("Rsq.avg.vect.zak0",min(seed.series),max(seed.series),sep=""), Rsq.avg.vect)
assign(paste("MAE.pred.vect.zak0",min(seed.series),max(seed.series),sep=""), MAE.pred.vect)
assign(paste("MAE.avg.vect.zak0",min(seed.series),max(seed.series),sep=""), MAE.avg.vect)