# Here below I try to fit with JAGS the model with only random effects in Linf
# you need the file "vb.model1.jag" in the same directory

library(R2jags) #### does not work as of 21st May 2014 with Mavericks OS

dataset.df = subset(allstreams.zakojska.df, Cohort!="C12" & Cohort!="C11" & Cohort!="P") 

# the option below is to select only fish with more than 3 observations
#######3
marktable.zak = with(dataset.df,table(Mark)) 
set.seed(1)
samplemark.zak = (sample(marktable.zak[marktable.zak>=4],120))


#dataset.df = subset(dataset.df, Mark %in% as.numeric(rownames(samplemark.zak)))
##########

Length <- log(dataset.df$Length)
T <- length(unique(dataset.df$Age))
N <- length(unique(dataset.df$Mark))
Age <- dataset.df$Age
unique.mark = unique(dataset.df$Mark)
Mark <-  dataset.df$Mark
Ntot <- nrow(dataset.df)
 
id = rep(0,nrow(dataset.df))

for (i in 1:nrow(dataset.df)) {

id[i] = which(unique.mark == Mark[i]) }
 
 

# Here below I prepare the data  
vb.data <- list(Length = Length,  Age = Age, id = id,
unique.mark = unique.mark, Ntot = Ntot)
 # Deﬁne the parameters you’re interested in:
 
 vb.params <- c("kpop","Linfpop","t0","Linf")
 
 # Deﬁne the starting values for JAGS
 

  
  vb.inits1 <- 
 list("Linfpop" = c(300),"Linf"=rep(0,length(unique.mark)), 
  "kpop" = c(0.16), "t0" =c(-0.1))
  vb.inits2 <- 
 list("Linfpop" = c(350),"Linf"=rep(0,length(unique.mark)), 
  "kpop" = c(0.3), "t0" =c(-0.4))
  vb.inits3 <- 
 list("Linfpop" = c(400),"Linf"=rep(0,length(unique.mark)), 
  "kpop" = c(0.2), "t0" =c(-0.2))
 
vb.inits <- list(vb.inits1, vb.inits2,vb.inits3)
 
vbfit.test.model <- jags.model(data=vb.data, inits=vb.inits, 
n.chains=3, n.adapt=100,file="vb.model1.jag")

## I just monitor 3 parameters 
vb.params = c("kpop","Linfpop","t0")

#date.start.jags = date()
 samps1 <- coda.samples(vbfit.test.model, vb.params, n.iter = 100000)
#date.end.jags = date() 
 plot(samps1)
 # it is clear that the procedure is not working
 